/****************************************************************/
/*								*/
/* GALer-Software						*/
/*								*/
/* Soft- and Hardware is copyright (c) 1991			*/
/*	 by Christian Habermann					*/
/*	    Asamstr. 17						*/
/*	    85356 Freising					*/
/*	    Germany						*/
/*								*/
/* This is Version 1.41 of GALer.				*/
/*								*/
/*								*/
/* used Compiler: SAS-C 6.0					*/
/* 								*/
/****************************************************************/


#include <devices/parallel.h>
#include <exec/io.h>
#include <exec/memory.h>
#include <exec/ports.h>
#include <exec/types.h>
#include <graphics/gfxbase.h>
#include <graphics/text.h>
#include <graphics/displayinfo.h>
#include <intuition/intuition.h>
#include <libraries/dosextens.h>
#include <libraries/reqtools.h>
#include <libraries/locale.h>
#include <libraries/gadtools.h>
#include <stdlib.h>

#include <clib/alib_protos.h>
#include <proto/locale.h>
#include <proto/reqtools.h>
#include <proto/intuition.h>
#include <proto/exec.h>
#include <proto/gadtools.h>


#include "GALer.h"
#include "Localize.h"



#define		Menu_1		0
#define		Menu_2		1
#define		Menu_3		2
#define		Menu_4		3
#define		Menu_5		4
#define		Menu_6		5

#define		Item_1		0
#define		Item_2		1
#define		Item_3		2
#define		Item_4		3
#define		Item_5		4
#define		Item_6		5
#define		Item_7		6
#define		Item_8		7
#define		Item_9		8


#define AsmGad_CNT	 8
#define WriteGad_CNT	 6
#define	JEDGad_CNT	 4
#define RAsm16_CNT	24
#define RAsm20_CNT	28
#define OptGad_CNT	 2


#ifdef LATTICE
int CXBRK(void)    { return(0); }  /* Disable Lattice CTRL/C handling */
int chkabort(void) { return(0); }  /* really */
#endif




extern	struct	ReqFileRequester	MyFileReqStruct;

extern	struct	NewGadget WriteNGad[], JEDNGad[], AsmNGad[], OptNGad[];
extern	struct	NewGadget RAsm16NGad[], RAsm20NGad[];

extern	UWORD	WriteGTypes[], JEDGTypes[], AsmGTypes[], OptGTypes[];
extern	UWORD	RAsm16GTypes[], RAsm20GTypes[];

extern	ULONG	WriteGTags[], JEDGTags[], AsmGTags[], OptGTags[];
extern	ULONG	RAsm16GTags[], RAsm20GTags[];




struct	IORequest	*CreateExtIO();
struct	IntuitionBase	*IntuitionBase;
struct	GfxBase		*GfxBase;
struct	LocaleBase	*LocaleBase;
struct	ReqToolsBase	*ReqToolsBase;
struct  Library		*GadToolsBase;
struct	IntuiMessage	*message;
struct	Screen		*screen;
struct	Window		*window,*old_ReqWin;
struct	MsgPort		*timeport, *parport;
struct	timerequest	*timereq;
struct	IOExtPar	*parreq;
struct	Menu		*mainmenu, *pruefermenu;
struct	rtFileRequester	*filereq;
struct	Gadget		*WriteGList, *JEDGList, *AsmGList, *OptGList;
struct	Gadget		*RAsm16GList, *RAsm20GList;

struct	Catalog		*catalog;

APTR	VisualInfo;



struct TextAttr topaz8 = { (STRPTR)"topaz.font", 8, 0x00, 0x01};





UBYTE  title[] = "GALer V1.41   1993 by Christian Habermann                 GAL16V8  ";



struct NewMenu MainNewMenu[] = {
	/* Project menu */
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L,   NULL,
	NM_ITEM,  NULL, NULL, 0, 0L,   NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L,   NULL,

	/* GAL-Type menu */
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL, NULL, CHECKIT, 2L, NULL,
	NM_ITEM,  NULL, NULL, CHECKIT, 1L, NULL,
	NM_ITEM,  NULL, NULL, CHECKIT|MENUTOGGLE, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, CHECKIT|MENUTOGGLE, 0L, NULL,
	NM_ITEM,  NULL, NULL, CHECKIT|MENUTOGGLE, 0L, NULL,

	/* GAL menu */
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,

	/* GAL-Assembler menu */
	NM_TITLE, NULL,	NULL, 0, NULL, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,

	/* GAL-Disassembler menu */
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,

	/* Tools menu */
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL,	NULL, 0, 0L, NULL,
	NM_ITEM,  (STRPTR)NM_BARLABEL, NULL, 0, 0L, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L, NULL,
	NM_END,   NULL, NULL, 0, 0L, NULL };



struct NewMenu PrueferNewMenu[] = {
	NM_TITLE, NULL, NULL, 0, NULL, NULL,
	NM_ITEM,  NULL, NULL, 0, 0L,   NULL,
	NM_END,   NULL, NULL, 0, 0L, NULL };



struct ColorSpec ScreenColors[] = { 0, 0x0A, 0x0A, 0x0A,
				    1, 0x00, 0x00, 0x00,
				    2, 0x0F, 0x0F, 0x0F,
				    3, 0x06, 0x08, 0x0B,
				   ~0, 0x00, 0x00, 0x00 };


UWORD DriPens[] = { 0xFFFF };





SHORT  BorderVectors1[]  = {0,0,17,0,17,9,0,9,0,0};
struct Border    Border1 = {-1,-1,2,3,JAM1,5,BorderVectors1,NULL};
struct Border    Border2 = {-1,-1,3,3,JAM1,5,BorderVectors1,NULL};


struct IntuiText IText35 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText34 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText33 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText32 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText31 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText30 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText29 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText28 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText27 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText26 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText25 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText24 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText23 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText22 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};
struct IntuiText IText21 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText20 = {2,0,JAM2,4,0,NULL,(UBYTE *)"O",NULL};

struct IntuiText IText13 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText12 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText11 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText10 = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText9  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText8  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText7  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText6  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText5  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText4  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};

struct IntuiText IText1c = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText3  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText2  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};
struct IntuiText IText1  = {2,0,JAM2,4,0,NULL,(UBYTE *)"L",NULL};


struct Gadget    Gadget35= {NULL,382,120,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText35,NULL,NULL,15,NULL};
struct Gadget    Gadget34= {&Gadget35,340,120,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText34,NULL,NULL,30,NULL};
struct Gadget    Gadget33= {&Gadget34,382,110,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText33,NULL,NULL,16,NULL};
struct Gadget    Gadget32= {&Gadget33,340,110,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText32,NULL,NULL,31,NULL};
struct Gadget    Gadget31= {&Gadget32,382,100,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText31,NULL,NULL,17,NULL};
struct Gadget    Gadget30= {&Gadget31,340,100,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText30,NULL,NULL,32,NULL};
struct Gadget    Gadget29= {&Gadget30,382,90,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText29,NULL,NULL,18,NULL};
struct Gadget    Gadget28= {&Gadget29,340,90,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText28,NULL,NULL,33,NULL};
struct Gadget    Gadget27= {&Gadget28,382,80,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText27,NULL,NULL,19,NULL};
struct Gadget    Gadget26= {&Gadget27,340,80,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText26,NULL,NULL,34,NULL};
struct Gadget    Gadget25= {&Gadget26,382,70,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText25,NULL,NULL,20,NULL};
struct Gadget    Gadget24= {&Gadget25,340,70,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText24,NULL,NULL,35,NULL};
struct Gadget    Gadget23= {&Gadget24,382,60,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText23,NULL,NULL,21,NULL};
struct Gadget    Gadget22= {&Gadget23,340,60,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText22,NULL,NULL,36,NULL};
struct Gadget    Gadget21= {&Gadget22,382,50,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border2,NULL,&IText21,NULL,NULL,22,NULL};
struct Gadget    Gadget20= {&Gadget21,340,50,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText20,NULL,NULL,37,NULL};

struct Gadget    Gadget13= {&Gadget20,382,130,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText13,NULL,NULL,10,NULL};
struct Gadget    Gadget12= {&Gadget13,242,120,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText12,NULL,NULL,9,NULL};
struct Gadget    Gadget11= {&Gadget12,242,110,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText11,NULL,NULL,8,NULL};
struct Gadget    Gadget10= {&Gadget11,242,100,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText10,NULL,NULL,7,NULL};
struct Gadget    Gadget9 = {&Gadget10,242,90,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText9,NULL,NULL,6,NULL};
struct Gadget    Gadget8 = {&Gadget9,242,80,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText8,NULL,NULL,5,NULL};
struct Gadget    Gadget7 = {&Gadget8,242,70,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText7,NULL,NULL,4,NULL};
struct Gadget    Gadget6 = {&Gadget7,242,60,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText6,NULL,NULL,3,NULL};
struct Gadget    Gadget5 = {&Gadget6,242,50,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText5,NULL,NULL,2,NULL};
struct Gadget    Gadget4 = {&Gadget5,242,40,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText4,NULL,NULL,1,NULL};

struct Gadget    Gadget1c= {NULL,382,120,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText1c,NULL,NULL,14,NULL};
struct Gadget    Gadget3 = {&Gadget1c,242,30,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText3,NULL,NULL,13,NULL};
struct Gadget    Gadget2 = {&Gadget3,382,30,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText2,NULL,NULL,12,NULL};
struct Gadget    Gadget1 = {&Gadget2,242,20,16,8,NULL,
			    GADGIMMEDIATE+RELVERIFY,BOOLGADGET,
			    (APTR)&Border1,NULL,&IText1,NULL,NULL,11,NULL};



struct	Process		*myproc;

struct	RastPort	*rp;
struct	ViewPort	*vp;

int	pruef_mode;

long	monitorID;


extern 	int	GALType, MaxFuseAdr, SigAdr;

extern	struct	Configuration	Config;






void main(void)
{
ULONG	class;
USHORT	code,	 gadID;
struct	Gadget	 *gad;
struct  MenuItem *menuitem;




 OpenStuff();					/*Libs, Windows... ffnen*/



 rp = &screen->RastPort;		/* RastPort- und Viewport-Zeiger */
 vp = &screen->ViewPort;		/* initiealisieren */


					/* Graphik an PAL/NTSC anpfassen */
 if (monitorID == PAL_MONITOR_ID) 	/* PAL ?*/
   DrawBevelBox(rp, 5L, 200L, 630L, 55L, GTBB_Recessed, TRUE, GT_VisualInfo, VisualInfo, TAG_DONE);
 
 DrawBevelBox(rp, 28L, 160L, 584L, 35L, GTBB_Recessed, TRUE, GT_VisualInfo, VisualInfo, TAG_DONE);



 if (GetParPort()) {				/*Druckerport frei?*/
   puts((char *)GetCatalogStr(catalog, MSG_ERR_PARPORT, (STRPTR)"parallel port is not available"));
   CloseStuff();
   exit(0);
  }

 if (GetTimer()) {				/*Timer holen*/
   FreeParPort();
   puts((char *)GetCatalogStr(catalog, MSG_ERR_TIMER, (STRPTR)"can't get timer"));
   CloseStuff();
   exit(0);    
  }


 InitGALer();					/*Ausgnge von IC3,4,5 auf*/
 EnableOutput();				/*LOW schalten*/

 LoadConfig();					/* Voreinstellung laden */



	/* GadTools-Gadgets erstellen */

 if (InitMyGadgets()) {
   puts((char *)GetCatalogStr(catalog, MSG_ERR_MEMORY, (STRPTR)"not enough free memory"));
   CloseStuff();
   FreeTimer();
   FreeParPort();
   exit(0);
 }




 for (;;)  {
   Wait(1L << window->UserPort->mp_SigBit);
   while (message = (struct IntuiMessage *)GetMsg(window->UserPort)) {

     class = message->Class;
     code  = message->Code;

     if (class == GADGETUP) {
       gad   = (struct Gadget *)message->IAddress;
       gadID = gad->GadgetID;
     }

     ReplyMsg((struct Message *)message);

     switch (class) {

	case MENUHELP:

		if (pruef_mode == ON)
		  HelpOnCheckerMenu(code);
		else
		  HelpOnMainMenu(code);

		break;		


	case MENUPICK:

		while (code != MENUNULL) {
		  if (pruef_mode != ON)
		    menuitem = ItemAddress(mainmenu, (ULONG)code);
		  else
		    menuitem = ItemAddress(pruefermenu, (ULONG)code);


		  if (MENUNUM(code) != MENUNULL)
		    ExecuteMenu(MENUNUM(code), ITEMNUM(code));	  

		  code = menuitem -> NextSelect;
		}

		break;


	case GADGETUP:

		if ((gadID < 100) && (pruef_mode == ON))
		  Pruefer(gad, gadID);

		break;


	case RAWKEY:

		if (code == 0x5F)		/* Help key? */
		  Help();

		break;

      }
    }
  }

}	 /*end of main*/






/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*				Subroutinen				*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


/*aufgerufenes Men ausfhren*/
void ExecuteMenu(int menu, int item)
{

 if (pruef_mode == ON) {
   if ((menu == Menu_1) && (item == Item_1))
     TogglePruefer();
 }
 else {

   switch (menu) {

     case Menu_1:					/*Projekt*/

       switch (item) {

	 case Item_1:
	   About();
	   break;

	 case Item_2:
	   SaveConfig();
	   break;

	 case Item_4:
	   CloseStuff();
	   FreeTimer();
	   FreeParPort();
	   exit(0);
	   break;

	}
       break;

     case Menu_2:					/*GAL-Typ*/

       switch (item) {

	 case Item_1:
	    SetGALType(GAL16V8, Config.AType);
	    break;

	 case Item_2:
	    SetGALType(GAL20V8, Config.AType);
	    break;

	 case Item_3:
	    SetGALType(GALType, !Config.AType);
	    break;

	 case Item_5:
	    Config.AutoAType = !Config.AutoAType;
	    if (Config.AutoAType)			  /* A-Typ-Men */
	      ItemAddress(mainmenu, FULLMENUNUM(1, 2, NOSUB))->Flags &= ~ITEMENABLED;
	    else					  /* A-Typ-Men */
	      ItemAddress(mainmenu, FULLMENUNUM(1, 2, NOSUB))->Flags |= ITEMENABLED;
	    break;

	 case Item_6:
	    Config.GALTypeReq = !Config.GALTypeReq;
	    break;

	}
       break;

     case Menu_3:					/*GAL*/

       switch (item) {

	 case Item_1:
	   ProgramGAL();				/*programmieren*/
	   break;

	 case Item_2:					/*kopieren*/
	   CopyGAL();
	   break;

	 case Item_3:					/*lschen*/
	   Loeschen();
	   break;

	 case Item_4:					/*vergleichen*/
	   Compare();
	   break;

	 case Item_5:					/*Leertest*/
	   Leertest();
	   break;

	 case Item_6:					/*setze Sec.*/
	   SetSecurity(YES);
	   break;

	 case Item_7:
	   TestSecurity();				/*teste Sec.*/
	   break;

	 case Item_9:
	   Schreibverhalten();
	   break;
        }
       break;

     case Menu_4:					/*GAL-Assembler*/
	 if (item == Item_1) {
	   AssembleInputFile(ASSEMBLER);	/*Eingabe-Datei assemblieren*/
	   break;
	  }
       break;

     case Menu_5:					/*GAL-Disassembler*/

       switch (item) {

	 case Item_1:
	   PrintSignature();
	   break;

	 case Item_2:
	   PrintACW();
	   break;

	 case Item_3:
	   GALInfo();
	   break;

	 case Item_5:
	   PutJedec();
	   break;

	 case Item_6:
	   JedecRequester();
	   break;

	 case Item_8:
	   Reassembler();
	   break;
	}
       break;

     case Menu_6:					/*Tools*/

       switch (item) {

	 case Item_1:
	   PrintPinNames();
	   break;

	 case Item_2:
	   ClearPinNames();
	   break;

	 case Item_3:
	   TogglePruefer();
	   break;

	 case Item_5:
	   Optimizer();
	   break;

	 case Item_7:
	   Help();
	   break;

       }
   }
 }   
}





/* Parallel-Port belegen
*/
int GetParPort(void)
{

 parport = (struct MsgPort *)CreatePort(0L,0L);
 if (parport == NULL)
   return(-1);

 parreq = (struct IOExtPar *) CreateExtIO(parport,(long)sizeof(struct IOExtPar));
 if (parreq == NULL) {
   DeletePort(parport);
   return(-1);
  }

 if (OpenDevice((BYTE *)"parallel.device",0L,(struct IORequest *)parreq,0L)) {
   DeleteExtIO((struct IORequest *)parreq);
   DeletePort(parport);
   return(-1);
  }

 InitParPort();				/*Datenrichtungsregister der CIAs*/
					/*initialisieren*/
 return(0);
}




/* Parallel-Port wieder freigeben
*/
void FreeParPort(void)
{
 RestoreParPort();		/*Datenrichtungsregister der CIAs restau-*/
				/*rieren, nicht aber den Zustand der Aus-*/
				/*gnge, da sonst der angeschlossene Brenner*/
				/*einen ungewollten Befehl erhalten knnte*/
				/*(Vcc on, VEdit on,...).*/
 CloseDevice((struct IORequest *)parreq);	/* Port wieder freigeben */
 DeleteExtIO((struct IORequest *)parreq);
 DeletePort(parport);
}





/* Timer holen
*/
int GetTimer(void)
{

 timeport = (struct MsgPort *)CreatePort(0L,0L);
 if (timeport == NULL)
   return(-1);

 timereq=(struct timerequest *)AllocMem(
			(long)sizeof(struct timerequest),MEMF_PUBLIC);
 if (timereq == NULL) {
   DeletePort(timeport);
   return(-1);
  }

 timereq->tr_node.io_Message.mn_Node.ln_Type = NT_MESSAGE;
 timereq->tr_node.io_Message.mn_Node.ln_Pri = 0;
 timereq->tr_node.io_Message.mn_ReplyPort = timeport;

 if (OpenDevice (TIMERNAME, UNIT_MICROHZ, (struct IORequest *)timereq, 0L)) {
   FreeMem(&timereq, (long)sizeof(struct timerequest));
   DeletePort (timeport);
   return (-1);
  }

 return(0);
}





/* Timer-Device wieder freigeben
*/
void FreeTimer(void)
{
  CloseDevice ((struct IORequest *)timereq);

  FreeMem (timereq, (long)sizeof(struct timerequest));

  DeletePort (timeport);
}





/* 
** micro: microsec. to wait
** secs: seconds to wait
*/
void WaitForTimer(ULONG micro)
{

  timereq->tr_node.io_Command = TR_ADDREQUEST;
  timereq->tr_time.tv_secs = 0;
  timereq->tr_time.tv_micro = micro;

  DoIO ((struct IORequest *)timereq);
}





/* Screen, Window, Libraries usw. ffnen
*/
void OpenStuff(void)
{

int scr_height, win_height;


  if (!(LocaleBase = (struct LocaleBase *)OpenLibrary("locale.library", 38L))) {
    puts("can't open locale.library version 38");
    CloseStuff();
    exit(0);
  }

  catalog = OpenCatalog(NULL, (STRPTR)"GALer.catalog", OC_Version, 1, TAG_DONE);

  LocalizeText();



  if (!(IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 37L))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_INTUITIONLIB, (STRPTR)"can't open intuition.library version 37"));
    exit(0);
  }


  if (!(GadToolsBase = OpenLibrary("gadtools.library", 37L))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_GADTOOLSLIB, (STRPTR)"can't open gadtools.library version 37"));
    CloseStuff();
    exit(0);
  }


  if (!(GfxBase = (struct GfxBase *)OpenLibrary("graphics.library", 37L))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_GRAPHICSLIB, (STRPTR)"can't open graphics.library version 37"));
    CloseStuff();
    exit(0);
  }


  if (!(ReqToolsBase = (struct ReqToolsBase *)OpenLibrary(REQTOOLSNAME, REQTOOLSVERSION))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_REQTOOLSLIB, (STRPTR)"can't open reqtools.library"));
    CloseStuff();
    exit(0);
  }


  if (!(filereq = rtAllocRequestA(RT_FILEREQ, NULL))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_FILEREQ, (STRPTR)"not enough free memory for file requester"));
    CloseStuff();
    exit(0);
  }


					/* Screen und Window an PAL/NTSC anpassen*/
  if (GfxBase->DisplayFlags & NTSC) {
    scr_height = 200;			/* NTSC */
    win_height = 189;
    monitorID  = NTSC_MONITOR_ID;
  }
  else {
    scr_height = 256;			/* PAL */
    win_height = 245;
    monitorID  = PAL_MONITOR_ID;
  }



  if (!(screen = OpenScreenTags( NULL, SA_Left,	0,
				SA_Top,		0,
				SA_Width,	640,
				SA_Height,	scr_height,
				SA_Depth,	2,
				SA_Colors,	&ScreenColors[0],
				SA_Font,	&topaz8,
				SA_Type,	CUSTOMSCREEN,
				SA_DisplayID,	monitorID|HIRES_KEY,
				SA_Pens,	&DriPens[0],
				SA_Title,	&title[0],
				TAG_DONE ))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_OPENSCREEN, (STRPTR)"can't open screen"));
    CloseStuff();
    exit(0);
  }




  if (!(VisualInfo = GetVisualInfo(screen, TAG_DONE))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_MEMORY, (STRPTR)"not enough free memory"));
    CloseStuff();
    exit(0);
  }



	/* Hauptmen erstellen */

  if (!(mainmenu = CreateMenus(MainNewMenu, GTMN_FrontPen, 0L, TAG_DONE))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_MEMORY, (STRPTR)"not enough free memory"));
    CloseStuff();
    exit(0);
  }

  LayoutMenus(mainmenu, VisualInfo, GTMN_TextAttr, &topaz8, TAG_DONE);



	/* Men fr GAL-Prfer erstellen */

  if (!(pruefermenu = CreateMenus(PrueferNewMenu, GTMN_FrontPen, 0L, TAG_DONE))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_MEMORY, (STRPTR)"not enough free memory"));
    CloseStuff();
    exit(0);
  }

  LayoutMenus(pruefermenu, VisualInfo, GTMN_TextAttr, &topaz8, TAG_DONE);




  if (!(window = OpenWindowTags( NULL,
				 WA_Left,	 0,
				 WA_Top,	 11,
				 WA_Width,	 640,
				 WA_Height,	 win_height,
				 WA_IDCMP,	 IDCMP_MENUHELP|IDCMP_MENUPICK|IDCMP_GADGETUP|IDCMP_RAWKEY,
				 WA_Flags,	 WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_ACTIVATE,
				 WA_Title,	 NULL,
				 WA_Gadgets,	 &Gadget4,
				 WA_ScreenTitle, &title[0],
				 WA_CustomScreen, screen,
				 WA_MenuHelp,	 TRUE,
				 TAG_DONE ))) {
    puts((char *)GetCatalogStr(catalog, MSG_ERR_OPENWINDOW, (STRPTR)"can't open window"));
    CloseStuff();
    exit(0);
  }

  SetMenuStrip( window, mainmenu );
  GT_RefreshWindow( window, NULL );


  myproc     = (struct Process *)FindTask(0L);		/*Requester umleiten*/
  old_ReqWin = (struct Window *)myproc->pr_WindowPtr;
  myproc->pr_WindowPtr = (APTR)window;

}




void CloseStuff(void)
{


  myproc->pr_WindowPtr=(APTR)old_ReqWin;  /*Req. auf ursprngliches Window*/


  if (mainmenu) {
    ClearMenuStrip(window);
    FreeMenus(mainmenu);
  }

  if (pruefermenu) {
    ClearMenuStrip(window);
    FreeMenus(pruefermenu);
  }


  if ( window ) CloseWindow( window );

  if ( VisualInfo    ) FreeVisualInfo (VisualInfo);
  if ( filereq       ) rtFreeRequest (filereq);
  if ( screen        ) CloseScreen  (screen);
  if ( IntuitionBase ) CloseLibrary ((struct Library *)IntuitionBase);
  if ( GfxBase       ) CloseLibrary ((struct Library *)GfxBase);
  if ( ReqToolsBase  ) CloseLibrary ((struct Library *)ReqToolsBase);

  if ( LocaleBase    ) {
    CloseCatalog(catalog);
    CloseLibrary ((struct Library *)LocaleBase);
  }

  if ( GadToolsBase  ) {
    FreeGadgets(WriteGList);
    FreeGadgets(JEDGList);
    FreeGadgets(AsmGList);
    FreeGadgets(RAsm16GList);
    FreeGadgets(RAsm20GList);
    FreeGadgets(OptGList);
    CloseLibrary ((struct Library *)GadToolsBase);
  }

}






/* InitMyGadgets
** initialisiert die GadTools-Gadgets
** Ergebnis: 0: alles o.k., 1: Fehler
*/
int InitMyGadgets(void)
{
struct	NewGadget	ng;
struct	Gadget		*g;
UWORD	lc, tc;
UWORD   offx = screen->WBorLeft, offy = screen->WBorTop + screen->RastPort.TxHeight + 1;


					/* Gadgets fr Schreibverhalten */
  if (!(g = CreateContext(&WriteGList)))
    return(1);

  for (lc = 0, tc = 0; lc < WriteGad_CNT; lc++) {

    CopyMem((char *)&WriteNGad[lc], (char *)&ng, (long)sizeof(struct NewGadget));

    ng.ng_VisualInfo = VisualInfo;
    ng.ng_TextAttr   = &topaz8;
    ng.ng_LeftEdge  += offx;
    ng.ng_TopEdge   += offy;

    g = CreateGadgetA((ULONG)WriteGTypes[lc], g, &ng, (struct TagItem *)&WriteGTags[tc]);

    while (WriteGTags[tc])
      tc += 2;
    tc++;

    if (NOT g)
      return(1);
  }



					/* Gadgets fr JEDEC-Parameter */
  if (!(g = CreateContext(&JEDGList)))
    return(1);

  for (lc = 0, tc = 0; lc < JEDGad_CNT; lc++) {

    CopyMem((char *)&JEDNGad[lc], (char *)&ng, (long)sizeof(struct NewGadget));

    ng.ng_VisualInfo = VisualInfo;
    ng.ng_TextAttr   = &topaz8;
    ng.ng_LeftEdge  += offx;
    ng.ng_TopEdge   += offy;

    g = CreateGadgetA((ULONG)JEDGTypes[lc], g, &ng, (struct TagItem *)&JEDGTags[tc]);

    while (JEDGTags[tc])
      tc += 2;
    tc++;

    if (NOT g)
      return(1);
  }



					/* Gadgets fr Assembler */
  if (!(g = CreateContext(&AsmGList)))
    return(1);

  for (lc = 0, tc = 0; lc < AsmGad_CNT; lc++) {

    CopyMem((char *)&AsmNGad[lc], (char *)&ng, (long)sizeof(struct NewGadget));

    ng.ng_VisualInfo = VisualInfo;
    ng.ng_TextAttr   = &topaz8;
    ng.ng_LeftEdge  += offx;
    ng.ng_TopEdge   += offy;

    g = CreateGadgetA((ULONG)AsmGTypes[lc], g, &ng, (struct TagItem *)&AsmGTags[tc]);

    while (AsmGTags[tc])
      tc += 2;
    tc++;

    if (NOT g)
      return(1);
  }



					/* Gadgets fr Reassembler 16V8 */

  if (!(g = CreateContext(&RAsm16GList)))
    return(1);

  for (lc = 0, tc = 0; lc < RAsm16_CNT; lc++) {

     CopyMem((char *)&RAsm16NGad[lc], (char *)&ng, (long)sizeof(struct NewGadget));

     ng.ng_VisualInfo = VisualInfo;
     ng.ng_TextAttr   = &topaz8;
     ng.ng_LeftEdge  += offx;
     ng.ng_TopEdge   += offy;

     g = CreateGadgetA((ULONG)RAsm16GTypes[lc], g, &ng, (struct TagItem *)&RAsm16GTags[tc]);

     while (RAsm16GTags[tc])
       tc += 2;
     tc++;

     if (NOT g)
       return(1);
  }

					/* Gadgets fr Reassembler 20V8 */

  if (!(g = CreateContext(&RAsm20GList)))
    return(1);

  for (lc = 0, tc = 0; lc < RAsm20_CNT; lc++) {

     CopyMem((char *)&RAsm20NGad[lc], (char *)&ng, (long)sizeof(struct NewGadget));

     ng.ng_VisualInfo = VisualInfo;
     ng.ng_TextAttr   = &topaz8;
     ng.ng_LeftEdge  += offx;
     ng.ng_TopEdge   += offy;

     g = CreateGadgetA((ULONG)RAsm20GTypes[lc], g, &ng, (struct TagItem *)&RAsm20GTags[tc]);

     while (RAsm20GTags[tc])
       tc += 2;
     tc++;

     if (NOT g)
       return(1);
  }


					/* Gadgets fr Optimizer */

  if (!(g = CreateContext(&OptGList)))
    return( 1L );

  for (lc = 0, tc = 0; lc < OptGad_CNT; lc++ ) {

     CopyMem((char * )&OptNGad[ lc ], (char * )&ng, (long)sizeof(struct NewGadget));

     ng.ng_VisualInfo = VisualInfo;
     ng.ng_TextAttr   = &topaz8;
     ng.ng_LeftEdge  += offx;
     ng.ng_TopEdge   += offy;

     g = CreateGadgetA((ULONG)OptGTypes[lc], g, &ng, (struct TagItem *)&OptGTags[tc]);

     while (OptGTags[tc])
       tc += 2;
     tc++;

     if (NOT g)
       return(1);
  }




  return(0);

}




