/****************************************************************/
/*								*/
/* Help.c - this file includes the help functions		*/
/*								*/
/*								*/
/* used Compiler: SAS-C 6.0					*/
/* 								*/
/****************************************************************/


#include <exec/types.h>
#include <intuition/intuition.h>
#include <libraries/reqtools.h>
#include <libraries/locale.h>

#include <proto/reqtools.h>
#include <proto/locale.h>

#include "Localize.h"



extern	struct	Catalog  *catalog;


/* gibt fr die einzelnen Menpunkte des Hauptmens einen entsprechenden
** Hilfstext aus
*/
void HelpOnMainMenu(UWORD menuNumber)
{
UWORD menuNum, itemNum;


  menuNum = MENUNUM(menuNumber);
  itemNum = ITEMNUM(menuNumber);


  switch (menuNum) {

    case  0:

      switch (itemNum) {

	case  0:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU1ITEM1_HLP,
		"Selecting this menu will bring up a requester in which\n"
		"you can read who has done all this code."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  1:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU1ITEM2_HLP,
		"This function saves some settings to the file 's:GALer.config'.\n"
		"When starting GALer next time, GALer will read this file and\n"
		"set your saved settings again.\n"),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  3:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU1ITEM3_HLP,
		"Quit quits GALer, but ATTENTION! Handle this function with\n"
		"care: If you use this function too often, GALer will sell\n"
		"your Amiga's CPU.\n\n"
		"Are you thinking that I'm pulling your leg?\n"
		"Ohhhh no..., really not! I never would do this."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;

      }

      break;



    case  1:

      switch (itemNum) {

	case  0:
	case  1:
	case  2:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU2ITEM1_HLP,
		"With the menu items 'GAL16V8', 'GAL20V8' and'A-Type' you\n"
		"can select the type of GAL which you want to read/program\n"
		"next time. When 'Auto-A-Type' is selected, 'A-Type' is\n"
		"ghosted because GALer will automatically detect whether you\n"
		"have a A-type GAL or a standard GAL inserted."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  4:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU2ITEM4_HLP,
		"If you don't want to care about whether you have a\n"
		"A, B type or standard type GAL, select this menu item.\n"
		"GALer will then notice automatically what type of GAL\n"
		"you have inserted in the socket. You only have then to\n"
		"choose between 16V8 and 20V8 GALs. Therefore the menu\n"
		"item 'A-Type' is then disabled."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  5:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU2ITEM5_HLP,
		"Every time when GALer wants to read or program a GAL\n"
		"GALer will bring up a requester in which you can select\n"
		"the type of GAL you want to read or program. This selection\n"
		"overrides the state of the 'GAL16V8', 'GAL20V8' and\n"
		"'A-Type' menu items. If you don't want this behaviour of\n"
		"GALer, deselect the 'Type-Requester' menu item."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;

      }
      break;


    case  2:

      switch (itemNum) {

	case  0:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM1_HLP,
		"Program a GAL. This is the most importent function of\n"
		"GALer. After selecting this menu, GALer will bring up\n"
		"a file requester in which you can select the JEDEC file\n"
		"which you want to program into the GAL."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  1:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM2_HLP,
		"Copy a GAL. You can only copy a GAL if the security\n"
		"bit of the source GAL is not set and if the destination\n"
		"GAL is erased."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  2:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM3_HLP,
		"Erase a GAL. If you want to reprogram a GAL, the GAL\n"
		"must be erased. Do this with this function."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  3:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM4_HLP,
		"There are three differnt types of comparison. You can\n"
		"compare a GAL with several GALs, a GAL with several JEDEC\n"
		"files or a JEDEC file with several GALs."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  4:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM5_HLP,
		"This function tests whether a GAL is erased or not."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  5:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM6_HLP,
		"With this function you can set the security bit of a GAL.\n"
		"As a result of this, the logic matrix of the GAL can't be\n"
		"read any longer."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  6:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM7_HLP,
		"Test whether the security bit of a GAL is set or not."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  8:
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU3ITEM9_HLP,
		"This function brings up a requester in which you can select\n"
		"what GALer should do before or after programming, copying or\n"
		"erasing a GAL.\n"
		"programming: with blank test: before programming a GAL test\n"
		"                              whether it is erased or not\n"
		"             with verify:     verify the GAL after programming\n"
		" copying:    with blank test: test destination GAL whether\n"
		"                              it is erased or not\n"
		"             with verify:     verify programmed destination GAL\n"
		" erasing:    with blank test: test after erasing a GAL whether\n"
		"                              it is really cleared or not"),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;

      }
      break;



    case  3:

      if (!itemNum) {
	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU4ITEM1_HLP,
		"With this function you can assemble a source file. Just\n"
		"select the files which you want to be generated by the\n"
		"assembler and start the assembler."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
      }
      break;


    case  4:

      switch (itemNum) {

	case  0:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM1_HLP,
		"This functions reads the signature of a GAL and prints\n"
		"it on GALer's screen."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  1:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM2_HLP,
		"Reads the architecture control word (ACW) of a GAL and\n"
		"prints it on GALer's screen."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  2:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM3_HLP,
		"This function gives you some informations about the\n"
		"inserted GAL. This informations are not very importent\n"
		"for you, but GALer needs them very much."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  4:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM5_HLP,
		"This function reads the inserted GAL and generates a\n"
		"corresponding JEDEC file."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


 	case  5:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM6_HLP,
		"Selecting this menu puts up a requester in which you can\n"
		"determine parameters concerning the gereration of JEDEC files.\n"
		"Security bit: If this is enabled, GALer will write JEDEC files\n"
		"   in which a special flag is set. Reading this JEDEC file to\n"
		"   program a GAL will bring up a requester in which you can choose\n"
		"   to set the security bit after programming the GAL or not.\n"
		"Fuse-Checksum: If this is enabled, GALer will write JEDEC files\n"
		"   with a checksum calculated over all fuses.\n"
		"File-Checksum: If this is enabled, GALer will write JEDEC files\n"
		"   with a checksum calculated over all characters in this file."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;


	case  7:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU5ITEM8_HLP,
		"This function reads a JEDEC file and generates then the original\n"
		"source file. So you can read an unknown GAL and get back a source\n"
		"file with the Boolean equations."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	  break;

      }
      break;


    case  5:

      switch (itemNum) {

	case  0:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU6ITEM1_HLP,
		"This function prints the pin names of the last assembled\n"
		"source file."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	break;


	case  1:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU6ITEM2_HLP,
		"This function cleares the pin names from the screen."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	break;


	case  2:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU6ITEM3_HLP,
		"There you can check a programmed GAL whether it does\n"
		"this what you want to do it or not."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	break;


	case  4:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU6ITEM5_HLP,
		"This function optimizes your Boolean equations."),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	break;


	case  6:

	  rtEZRequestTags( GetCatalogStr(catalog, MSG_MENU6ITEM7_HLP,
		"This function shows you how to get help on GALer's functions.\n"
		"But since you have tried to get help on this menu item you know\n"
		"this already else you couldn't see this requester. :-)))"),
		GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
		NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);
	break;

      }
      break;

  }


  return;
}




/* gibt fr die einzelnen Menpunkte des GAL-Checker-Mens einen
**  entsprechenden Hilfstext aus
*/
void HelpOnCheckerMenu(UWORD menuNumber)
{
UWORD menuNum, itemNum;



  menuNum = MENUNUM(menuNumber);
  itemNum = ITEMNUM(menuNumber);


  if (!menuNum && !itemNum) {

    rtEZRequestTags( GetCatalogStr(catalog, MSG_CHKMENU1ITEM1_HLP,
	"This quits the GAL-Checker, but not GALer."),
	GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
	NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);

  }


  return;
}





void Help(void)
{

  rtEZRequestTags( GetCatalogStr(catalog, MSG_HELP_TXT,
	"To get help move the mouse pointer over the menu item on which you\n"
	"want to get help. Then press the Help key. After this a requester\n"
	"will pop up which shows you a help text."),
	GetCatalogStr(catalog, MSG_OK_GAD, "O.K."),
	NULL, NULL, RT_ReqPos, REQPOS_CENTERSCR, TAG_END);

  return;
}



